package jboss_log4j;

import java.util.Hashtable;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import jboss_log4j.common.Log4jServletInit;

import org.jboss.logging.Logger;

public class JBossLog4jTest {

	private static Logger logger = Log4jServletInit.getLogger(JBossLog4jTest.class,"/META-INF/log4j.xml");
	
	public JBossLog4jTest() {
		super();
	}

	public void sendMessage(String traced_value) {
		logger.info("sendMessage start..");

		// send the message via controller queue
		logger.info("Traced Value :"+traced_value);
		Map<String,String> messageParams = new Hashtable<String,String>();
		messageParams.put("traced_value", traced_value);
		messageParams.put("my_message", "Hello from JBossLog4jTest");
		// create a connection to a controller queue 
		Connection connection = null;
		Session session = null;
		MessageProducer producer = null;
		Context ctx;
		ConnectionFactory connectionFactory;
		Queue controllerQueue;
		try {
			
			ctx 				= new InitialContext();
			connectionFactory 	= (ConnectionFactory)ctx.lookup("ConnectionFactory");
			logger.debug("ConnectionFactory ready.");
			controllerQueue 	= (Queue)ctx.lookup("queue/JBossLog4jTestMDBQueue");
			logger.debug("Queue ready.");
			connection 			= connectionFactory.createConnection();
			session 			= connection.createSession(false, QueueSession.AUTO_ACKNOWLEDGE);
			producer 			= session.createProducer(controllerQueue);	
			logger.debug("MessageProducer ready.");
			Message message 	= session.createMessage();
			for (String key : messageParams.keySet()) {
				message.setStringProperty(key, messageParams.get(key));
			}
			// specify a message expiration
			int messageTTL		= 10*1000;	// 10 sec
			message.setJMSExpiration(messageTTL);

			// send a message
			producer.send(message);			
		} catch (NamingException e) {
			logger.error("Send Message NamingException: "+e.getMessage());
			e.printStackTrace();
		} catch (JMSException e) {
			logger.error("Send Message JMSException: "+e.getMessage());
			e.printStackTrace();
		}
		logger.info("Message successfully sent.");		
	}

}
