package jboss_log4j.ejb;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Message;

import jboss_log4j.common.Log4jServletInit;

import org.jboss.logging.Logger;


@MessageDriven(activationConfig =
{
	@ActivationConfigProperty(propertyName="destinationType", propertyValue="javax.jms.Queue"),
	@ActivationConfigProperty(propertyName="destination", propertyValue="queue/JBossLog4jTestMDBQueue")
}) 
public class JBossLog4jTestMDB  implements javax.jms.MessageListener{

	private static final long serialVersionUID = 1L;
	private static Logger logger=Log4jServletInit.getLogger(JBossLog4jTestMDB.class,"/META-INF/log4j.xml");
	// hash code of this object:
	private int hashCode;

	@PostConstruct
	public void ejbCreate() {
		hashCode = this.hashCode();
		logger.info("JBossLog4jTestMDB created: " + hashCode);
	}

	@PreDestroy
	public void ejbRemove() {
		logger.info("JBossLog4jTestMDB removed: " + hashCode);
	}	
	
	public void onMessage(Message message) {
		logger.debug("->Start, thread ID: "+Thread.currentThread().getId());
		logger.info("Message received: "+message);
	}
}
